﻿Imports System.Text
Imports System.Speech
Imports System.Speech.Synthesis
Imports WMPLib
Imports System.Media
Imports System.IO

Public Class GeneralActions

#Region "Speech Actions"
    Private Shared syn As New SpeechSynthesizer
    Private Shared speakQ As New Queue(Of String) 'todo make a queue of speech objects so we can free up threads from waiting on speaking commands => more responsive to "barge in"

    Public Shared Sub Speak(ByVal words As String)
        syn.Speak(words)
    End Sub

    Public Shared Sub SpeakAsync(ByVal words As String)
        syn.SpeakAsync(words)
    End Sub

    Public Shared Sub Goodbye(ByVal name As String)
        syn.Speak("Goodbye " & name & ". It was my pleasure to serve you.")
    End Sub

    Public Shared Sub Greet(ByVal name As String)
        Dim greet As String = "Hello "
        Dim hour As Integer = Date.Now.TimeOfDay.Hours
        If hour < 12 Then
            greet = "Good morning "
        ElseIf hour < 17 Then
            greet = "Good afternoon "
        Else
            greet = "Good evening "
        End If

        syn.Speak(greet & name & ".")
    End Sub

    Public Shared Sub SayTime()
        Dim text As String = ""
        Dim [end] As String = ""
        Dim str_hour As String = ""
        Dim hour As Integer = Date.Now.TimeOfDay.Hours
        'todo: refine this model to be more robust
        If hour > 12 Then
            str_hour = (hour - 12).ToString
            [end] = "P M"
        Else
            str_hour = hour.ToString
            [end] = "A M"
        End If
        Dim minutes As Integer = Date.Now.TimeOfDay.Minutes
        If minutes < 31 Then
            'minutes less than 31 => express as minutes after
            text = "The time is " & minutes.ToString & " minutes after " & str_hour & " " & [end]
        Else
            'minutes greater than 30 => express as minutes until
            minutes = 60 - minutes
            hour += 1
            If hour = 24 Then
                'it is about to be midnight
                str_hour = "midnight"
                [end] = ""
            ElseIf hour = 12 Then
                str_hour = "noon"
                [end] = ""
            Else
                str_hour = hour.ToString
                If hour < 12 Then
                    [end] = "A M"
                Else
                    [end] = "P M"
                End If
            End If
            text = "There are " & minutes & " minutes until " & str_hour & [end]
        End If

        Actions.GeneralActions.Speak(text)
    End Sub
#End Region

#Region "Application Actions"
    Public Shared Sub StartWMP(ByVal filepath As String)
        Dim wmp As WMPLib.WindowsMediaPlayer = New WindowsMediaPlayer
        wmp.URL = filepath
        wmp.controls.play()
    End Sub

    Public Shared Sub StartDefaultAudioPlayer(ByVal filepath As String)
        Process.Start(filepath)
    End Sub
#End Region

End Class
