﻿Imports System.Text

Public Class Person
    Public Enum Gender
        Unknown = 0
        Female
        Male
    End Enum

    Private _lastGreeted As Date
    Public Property LastGreeted As Date
        Get
            Return _lastGreeted
        End Get

        Set(ByVal value As Date)
            _lastGreeted = value
        End Set
    End Property

    Private _personId As Guid
    Public ReadOnly Property PersonId As Guid
        Get
            Return _personId
        End Get
    End Property

    Private _rfid As String
    Public Property Rfid As String
        Get
            Return _rfid
        End Get

        Set(ByVal value As String)
            _rfid = value
        End Set
    End Property

    Private _gender As Gender
    Public Property PersonGender As Gender
        Get
            Return _gender
        End Get

        Set(ByVal value As Gender)
            _gender = value
        End Set
    End Property

    Private _full_name As String
    Public Property Full_name As String
        Get
            Return _full_name
        End Get

        Set(ByVal value As String)
            _full_name = value
        End Set
    End Property

    Private _preferred_name As String
    Public Property Preferred_name As String
        Get
            Return _preferred_name
        End Get

        Set(ByVal value As String)
            _preferred_name = value
        End Set
    End Property

    Private _histogram As Histogram
    Public Property Histogram As Histogram
        Get
            Return _histogram
        End Get

        Set(ByVal value As Histogram)
            _histogram = value
        End Set
    End Property

    Private _skeletonId As String
    Public Property SkeletonId As String
        Get
            Return _skeletonId
        End Get

        Set(ByVal value As String)
            _skeletonId = value
        End Set
    End Property

    Public Function greetedToday() As Boolean
        If Me._lastGreeted.ToShortDateString = Date.Now.ToShortDateString Then
            Return True
        End If

        Return False
    End Function

    Public Overrides Function GetHashCode() As Integer
        Return _personId.GetHashCode ' Base.GetHashCode()
    End Function

    Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        If obj.GetType IsNot GetType(Person) Then
            'obj is not a Person => cannot be equal
            Return False
        End If
        'obj is of type Person => let's do the comparison
        Dim other As Person = CType(obj, Person)
        Return ((Me.Rfid = other.Rfid) AndAlso (Me.Full_name = other.Full_name) AndAlso (Me.Preferred_name = other.Preferred_name))
    End Function

#Region "Constructors"
    ''' <summary>
    ''' Public default constructor.
    ''' </summary>
    Public Sub New()
        _personId = Guid.NewGuid
    End Sub

    Public Sub New(ByVal rfid As String, ByVal gend As Gender, ByVal fullname As String, ByVal preferredName As String)
        Me._gender = gend
        Me._rfid = rfid
        Me._full_name = fullname
        Me._preferred_name = preferredName
        _personId = Guid.NewGuid
    End Sub

    ''' <summary>
    ''' Constructor for Person object.
    ''' </summary>
    ''' <param name="id">[in] Guid that represents the Id of the person - unique identifier.</param>
    Public Sub New(ByVal id As Guid)
        _personId = id
    End Sub
#End Region

End Class
