﻿Imports System.Resources
Imports System.Text
Imports System.Windows.Controls.Primitives
Imports System.Windows.Threading
Imports Actions
Imports System.Threading
Imports LilyNUI
Imports Microsoft.Research.Kinect.Nui
'Phidgets is the rfid reader that I used in the project for GMU - removed from code because most will not already have 
'Imports Phidgets
'Imports Phidgets.Events
Imports System.Runtime.InteropServices
Imports System.Reflection
Imports Coding4Fun.Kinect.Wpf
Imports Coding4Fun.Kinect.Wpf.Controls
Imports System.Net
Imports System.Xml

''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window

#Region "Class Member Variables"
    Private _sp_tkr As SpeechTracker

    Private _nui As Runtime

    'Private rfid As RFID
    Private _currentRFIDTag As String

    Private _rfidHistory As Queue(Of String)

    Private _knownPeople As Dictionary(Of String, Person)

    Private _nuiInitialized As Boolean = False

    Private _pulseResponses() As String

    Private _context As LilyContext = LilyContext.GetLilyContext

    Private _buttons As List(Of Button)

    Private Shared _isClosing As Boolean = False

    Private Shared _handLeft As Double

    Private Shared _handTop As Double

    Private Shared _selectedButton As Button = Nothing

    Private _trackHands As Boolean = False

    Private _cameraControl As CameraControl = CameraControl.Course

    Private _totalFrames As Integer = 0

    Private _lastFrames As Integer = 0

    Private _lastTime As Date = Date.MaxValue

    ' We want to control how depth data gets converted into false-color data
    ' for more intuitive visualization, so we keep 32-bit color frame buffer versions of
    ' these, to be updated whenever we receive and process a 16-bit frame.
    Private Const RED_IDX As Integer = 2

    Private Const GREEN_IDX As Integer = 1

    Private Const BLUE_IDX As Integer = 0

    Private _depthFrame32(320 * 240 * 4 - 1) As Byte

    Private _jointColors As New Dictionary(Of JointID, Brush) From {{JointID.HipCenter,
                                                                    New SolidColorBrush(Color.FromRgb(169, 176, 155))},
                                                                   {JointID.Spine, New SolidColorBrush(Color.FromRgb(169, 176, 155))},
                                                                   {JointID.ShoulderCenter, New SolidColorBrush(Color.FromRgb(168, 230, 29))},
                                                                   {JointID.Head, New SolidColorBrush(Color.FromRgb(200, 0, 0))},
                                                                   {JointID.ShoulderLeft, New SolidColorBrush(Color.FromRgb(79, 84, 33))},
                                                                   {JointID.ElbowLeft, New SolidColorBrush(Color.FromRgb(84, 33, 42))},
                                                                   {JointID.WristLeft, New SolidColorBrush(Color.FromRgb(255, 126, 0))},
                                                                   {JointID.HandLeft, New SolidColorBrush(Color.FromRgb(215, 86, 0))},
                                                                   {JointID.ShoulderRight, New SolidColorBrush(Color.FromRgb(33, 79, 84))},
                                                                   {JointID.ElbowRight, New SolidColorBrush(Color.FromRgb(33, 33, 84))},
                                                                   {JointID.WristRight, New SolidColorBrush(Color.FromRgb(77, 109, 243))},
                                                                   {JointID.HandRight, New SolidColorBrush(Color.FromRgb(37, 69, 243))},
                                                                   {JointID.HipLeft, New SolidColorBrush(Color.FromRgb(77, 109, 243))},
                                                                   {JointID.KneeLeft, New SolidColorBrush(Color.FromRgb(69, 33, 84))},
                                                                   {JointID.AnkleLeft, New SolidColorBrush(Color.FromRgb(229, 170, 122))},
                                                                   {JointID.FootLeft, New SolidColorBrush(Color.FromRgb(255, 126, 0))},
                                                                   {JointID.HipRight, New SolidColorBrush(Color.FromRgb(181, 165, 213))},
                                                                   {JointID.KneeRight, New SolidColorBrush(Color.FromRgb(71, 222, 76))},
                                                                   {JointID.AnkleRight, New SolidColorBrush(Color.FromRgb(245, 228, 156))},
                                                                   {JointID.FootRight, New SolidColorBrush(Color.FromRgb(77, 109, 243))}}

    Public ReadOnly Property ContextHistoryCount As Integer
        Get
            Return _context.ContextHistory.Count
        End Get
    End Property
#End Region

#Region "Enumerations"
    Private Enum CameraControl
        Fine
        Course
    End Enum
#End Region

#Region "Constructors"
    Public Sub New()
        InitializeComponent()
        InitializeButtons()
        _pulseResponses = New String() {"Yes?", "Yes, {0}?", "I am listening.", "I am listening, {0}", "I am ready.", "I am ready, {0}", "I am here.", "How can I help you?", "{0}, how may I be of service?", "Can I do something?", "Do you need something?", "Do you need something, {0}?"}
        _rfidHistory = New Queue(Of String)(100) 'keep a history of the last 100 rfid tags read by the system
        GeneralActions.SpeakAsync("Starting up my components.")
        _context.EndUser = New Person("110033e117", Person.Gender.Male, "Leland Holmquest", "Leland")
        InitializeKinect()
        AddHandler _nui.VideoFrameReady, AddressOf nui_VideoFrameReady
        AddHandler _nui.SkeletonFrameReady, AddressOf nui_SkeletonFrameReady
        AddHandler _nui.DepthFrameReady, AddressOf nui_DepthFrameReady
        AddHandler kinectButton.Click, AddressOf kinectButton_Click
        _sp_tkr = _context.GetSpeechTracker
        AddHandler _sp_tkr.SpeechDetected, AddressOf sp_tkr_SpeechDetected
        AddHandler _sp_tkr.SpeechContextChanged, AddressOf sp_tkr_SpeechContextChanged
        AddHandler button1.Click, AddressOf button1_Click
        AddHandler button2.Click, AddressOf button2_Click
        AddHandler button3.Click, AddressOf button3_Click
        AddHandler button4.Click, AddressOf button4_Click
        AddHandler button5.Click, AddressOf button5_Click
        AddHandler button6.Click, AddressOf button6_Click
        AddHandler button7.Click, AddressOf button7_Click
        AddHandler button8.Click, AddressOf button8_Click
        txtBlkContextHistCnt.Text = _context.ContextHistory.Count.ToString
        'InitializeRFID()

        'load up the dictionary with known users
        ' this block not used without an rfid reader
        'LoadRfidAccounts()
    End Sub
#End Region

#Region "Private Methods"
    Private Sub kinectButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _selectedButton.RaiseEvent(New RoutedEventArgs(ButtonBase.ClickEvent, _selectedButton))
    End Sub

    Private Function getDisplayPosition(ByVal joint As Joint) As Point
        Dim depthX, depthY As Single
        _nui.SkeletonEngine.SkeletonToDepthImage(joint.Position, depthX, depthY)
        depthX = Math.Max(0, Math.Min(depthX * 320, 320)) 'convert to 320, 240 space
        depthY = Math.Max(0, Math.Min(depthY * 240, 240)) 'convert to 320, 240 space
        Dim colorX, colorY As Integer
        Dim iv As New ImageViewArea
        ' only ImageResolution.Resolution640x480 is supported at this point
        _nui.NuiCamera.GetColorPixelCoordinatesFromDepthPixel(ImageResolution.Resolution640x480, iv, CInt(Fix(depthX)), CInt(Fix(depthY)), CShort(Fix(0)), colorX, colorY)

        ' map back to skeleton.Width & skeleton.Height
        Return New Point(CInt(Fix(skeletonImage.Width * colorX / 640.0)), CInt(Fix(skeletonImage.Height * colorY \ 480)))
    End Function

    Private Function getBodySegment(ByVal joints As Microsoft.Research.Kinect.Nui.JointsCollection, ByVal brush As Brush, ByVal ParamArray ids() As JointID) As Polyline
        Dim points As New PointCollection(ids.Length)
        For i = 0 To ids.Length - 1
            points.Add(getDisplayPosition(joints(ids(i))))
        Next i

        Dim polyline As New Polyline
        polyline.Points = points
        polyline.Stroke = brush
        polyline.StrokeThickness = 5
        Return polyline
    End Function

    Private Sub renderSkeleton(ByVal sender As Object, ByVal e As SkeletonFrameReadyEventArgs)
        Dim skeletonFrame As SkeletonFrame = e.SkeletonFrame
        Dim iSkeleton As Integer = 0
        Dim brushes(5) As Brush
        brushes(0) = New SolidColorBrush(Color.FromRgb(255, 0, 0))
        brushes(1) = New SolidColorBrush(Color.FromRgb(0, 255, 0))
        brushes(2) = New SolidColorBrush(Color.FromRgb(64, 255, 255))
        brushes(3) = New SolidColorBrush(Color.FromRgb(255, 255, 64))
        brushes(4) = New SolidColorBrush(Color.FromRgb(255, 64, 255))
        brushes(5) = New SolidColorBrush(Color.FromRgb(128, 128, 255))

        skeletonImage.Children.Clear()
        For Each data As SkeletonData In skeletonFrame.Skeletons
            If SkeletonTrackingState.Tracked = data.TrackingState Then
                ' Draw bones
                Dim brush As Brush = brushes(iSkeleton Mod brushes.Length)
                skeletonImage.Children.Add(getBodySegment(data.Joints, brush, JointID.HipCenter, JointID.Spine, JointID.ShoulderCenter, JointID.Head))
                skeletonImage.Children.Add(getBodySegment(data.Joints, brush, JointID.ShoulderCenter, JointID.ShoulderLeft, JointID.ElbowLeft, JointID.WristLeft, JointID.HandLeft))
                skeletonImage.Children.Add(getBodySegment(data.Joints, brush, JointID.ShoulderCenter, JointID.ShoulderRight, JointID.ElbowRight, JointID.WristRight, JointID.HandRight))
                skeletonImage.Children.Add(getBodySegment(data.Joints, brush, JointID.HipCenter, JointID.HipLeft, JointID.KneeLeft, JointID.AnkleLeft, JointID.FootLeft))
                skeletonImage.Children.Add(getBodySegment(data.Joints, brush, JointID.HipCenter, JointID.HipRight, JointID.KneeRight, JointID.AnkleRight, JointID.FootRight))

                ' Draw joints
                For Each joint In data.Joints
                    Dim jointPos As Point = getDisplayPosition(joint)
                    Dim jointLine As New Line
                    jointLine.X1 = jointPos.X - 3
                    jointLine.X2 = jointLine.X1 + 6
                    jointLine.Y2 = jointPos.Y
                    jointLine.Y1 = jointLine.Y2
                    jointLine.Stroke = _jointColors(joint.ID)
                    jointLine.StrokeThickness = 6
                    skeletonImage.Children.Add(jointLine)
                Next joint
            End If
            iSkeleton += 1
        Next data ' for each skeleton
    End Sub

    Private Sub nui_SkeletonFrameReady(ByVal sender As Object, ByVal e As SkeletonFrameReadyEventArgs)
        renderSkeleton(sender, e)
        If Not _trackHands Then
            Exit Sub  ' if the user deosn't want to use the buttons, simply return
        End If
        If e.SkeletonFrame.Skeletons.Count = 0 Then
            Exit Sub  'no skeletons => don't bother processing
        End If
        Dim skeletonSet As SkeletonFrame = e.SkeletonFrame
        Dim firstPerson As SkeletonData = (
            From s In skeletonSet.Skeletons
            Where s.TrackingState = SkeletonTrackingState.Tracked
            Order By s.UserIndex Descending
            Select s).FirstOrDefault
        If firstPerson Is Nothing Then
            Return 'if no one is being tracked, no sense in continueing
        End If

        Dim joints As JointsCollection = firstPerson.Joints
        Dim righthand As Joint = joints(JointID.HandRight)
        Dim lefthand As Joint = joints(JointID.HandLeft)
        'use the heighth of the hand to figure out which is being used
        Dim joinCursorHand As Joint = If(righthand.Position.Y > lefthand.Position.Y, righthand, lefthand)

        Dim posX As Single = joinCursorHand.ScaleTo(CInt(Fix(SystemParameters.PrimaryScreenWidth)), CInt(Fix(SystemParameters.PrimaryScreenHeight))).Position.X
        Dim posY As Single = joinCursorHand.ScaleTo(CInt(Fix(SystemParameters.PrimaryScreenWidth)), CInt(Fix(SystemParameters.PrimaryScreenHeight))).Position.Y
        Dim scaledCursorJoint As Joint = New Joint With {.TrackingState = JointTrackingState.Tracked, .Position = New Microsoft.Research.Kinect.Nui.Vector With {.X = posX, .Y = posY, .Z = joinCursorHand.Position.Z}}
        OnButtonLocationChanged(kinectButton, _buttons, CInt(Fix(scaledCursorJoint.Position.X)), CInt(Fix(scaledCursorJoint.Position.Y)))
    End Sub

    Private Sub nui_DepthFrameReady(ByVal sender As Object, ByVal e As ImageFrameReadyEventArgs)
        Dim Image As PlanarImage = e.ImageFrame.Image
        Dim convertedDepthFrame() As Byte = convertDepthFrame(Image.Bits)

        depthImage.Source = BitmapSource.Create(Image.Width, Image.Height, 96, 96, PixelFormats.Bgr32, Nothing, convertedDepthFrame, Image.Width * 4)

        _totalFrames += 1

        Dim cur As Date = Date.Now
        If cur.Subtract(_lastTime) > TimeSpan.FromSeconds(1) Then
            Dim frameDiff As Integer = _totalFrames - _lastFrames
            _lastFrames = _totalFrames
            _lastTime = cur
        End If
    End Sub

    ' Converts a 16-bit grayscale depth frame which includes player indexes into a 32-bit frame
    ' that displays different players in different colors
    Private Function convertDepthFrame(ByVal depthFrame16() As Byte) As Byte()
        Dim i16 As Integer = 0
        Dim i32 As Integer = 0
        Do While i16 < depthFrame16.Length AndAlso i32 < _depthFrame32.Length
            Dim player As Integer = depthFrame16(i16) And &H7
            Dim realDepth As Integer = (depthFrame16(i16 + 1) << 5) Or (depthFrame16(i16) >> 3)
            ' transform 13-bit depth information into an 8-bit intensity appropriate
            ' for display (we disregard information in most significant bit)
            Dim intensity As Byte = CByte(255 - (255 * realDepth / &HFFF))

            _depthFrame32(i32 + RED_IDX) = 0
            _depthFrame32(i32 + GREEN_IDX) = 0
            _depthFrame32(i32 + BLUE_IDX) = 0

            ' choose different display colors based on player
            Select Case player
                Case 0
                    _depthFrame32(i32 + RED_IDX) = CByte(intensity \ 2)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(intensity \ 2)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(intensity \ 2)
                Case 1
                    _depthFrame32(i32 + RED_IDX) = intensity
                Case 2
                    _depthFrame32(i32 + GREEN_IDX) = intensity
                Case 3
                    _depthFrame32(i32 + RED_IDX) = CByte(intensity \ 4)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(intensity)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(intensity)
                Case 4
                    _depthFrame32(i32 + RED_IDX) = CByte(intensity)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(intensity)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(intensity \ 4)
                Case 5
                    _depthFrame32(i32 + RED_IDX) = CByte(intensity)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(intensity \ 4)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(intensity)
                Case 6
                    _depthFrame32(i32 + RED_IDX) = CByte(intensity \ 2)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(intensity \ 2)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(intensity)
                Case 7
                    _depthFrame32(i32 + RED_IDX) = CByte(255 - intensity)
                    _depthFrame32(i32 + GREEN_IDX) = CByte(255 - intensity)
                    _depthFrame32(i32 + BLUE_IDX) = CByte(255 - intensity)
            End Select
            i16 += 2
            i32 += 4
        Loop
        Return _depthFrame32
    End Function

    Private Sub OnButtonLocationChanged(ByVal hand As HoverButton, ByVal buttons As List(Of Button), ByVal X As Integer, ByVal Y As Integer)
        If IsButtonOverObject(hand, buttons) Then
            hand.Hovering()
        Else
            hand.Release()
        End If
        Canvas.SetLeft(hand, X - (hand.ActualWidth / 2))
        Canvas.SetTop(hand, Y - (hand.ActualHeight / 2))
    End Sub

    Private Shared Function IsButtonOverObject(ByVal hand As FrameworkElement, ByVal buttons As List(Of Button)) As Boolean
        If _isClosing OrElse (Not Window.GetWindow(hand).IsActive) Then
            Return False
        End If

        ' get the location of the top left of the hand and then use it to find the middle of the hand
        Dim handTopLeft = New Point(Canvas.GetTop(hand), Canvas.GetLeft(hand))
        _handLeft = handTopLeft.X + (hand.ActualWidth / 2)
        _handTop = handTopLeft.Y + (hand.ActualHeight / 2)

        For Each target In buttons
            Dim targetTopLeft As Point = target.PointToScreen(New Point)
            If _handTop > targetTopLeft.X AndAlso _handTop < targetTopLeft.X + target.ActualWidth AndAlso _handLeft > targetTopLeft.Y AndAlso _handLeft < targetTopLeft.Y + target.ActualHeight Then
                _selectedButton = target
                Return True
            End If
        Next target
        Return False
    End Function

    Private Sub nui_VideoFrameReady(ByVal sender As Object, ByVal e As ImageFrameReadyEventArgs)
        'pull out the video frame from the eventargs and load it into our image object
        Dim image As PlanarImage = e.ImageFrame.Image
        Dim source As BitmapSource = BitmapSource.Create(image.Width, image.Height, 96, 96, PixelFormats.Bgr32, Nothing, image.Bits, image.Width * image.BytesPerPixel)
        colorImage.Source = source
    End Sub

    'Private Sub InitializeRFID()
    '       Try
    '           'Initialize RFID reader
    '           rfid = New RFID
    '           AddHandler rfid.Attach, AddressOf rfid_Attach
    '           AddHandler rfid.Detach, AddressOf rfid_Detach
    '           AddHandler rfid.Error, AddressOf rfid_Error
    '           AddHandler rfid.Tag, AddressOf rfid_Tag
    '           AddHandler rfid.TagLost, AddressOf rfid_TagLost
    '           rfid.open()
    '           Console.WriteLine("Attaching rfid reader...")
    '           rfid.waitForAttachment(2000)
    '           rfid.Antenna = True
    '           rfid.LED = True
    '           rfid.LED = False
    '           Console.WriteLine("RFID reader is ready.")
    '       Catch comex As COMException
    '           LogEvent(comex.Message)
    '           LogEvent(comex.StackTrace)
    '           Actions.GeneralActions.Speak("There was a problem initializing the R F I D reader that I could not catch properly. Please check into it.")
    '           Actions.GeneralActions.Speak("The reader will be down until the problem is resolved. Thank you.")
    '       Catch ex As Exception
    '           Actions.GeneralActions.Speak("There was a problem initializing the R F I D reader. Please check the log for more information.")
    '           LogEvent(ex.Message)
    '           LogEvent(ex.StackTrace)
    '       End Try
    '   End Sub

    Private Sub InitializeKinect()
        Try
            'Initialize Kinect
            _nui = Runtime.Kinects(0) ' New Runtime
            _nui.Initialize(RuntimeOptions.UseDepthAndPlayerIndex Or RuntimeOptions.UseDepth Or RuntimeOptions.UseColor Or RuntimeOptions.UseSkeletalTracking)
            _nuiInitialized = True
            _nui.SkeletonEngine.TransformSmooth = True
            _nui.SkeletonEngine.SmoothParameters = New TransformSmoothParameters With {.Smoothing = 0.75F, .Correction = 0.0F, .Prediction = 0.0F, .JitterRadius = 0.05F, .MaxDeviationRadius = 0.04F}
            _nui.VideoStream.Open(ImageStreamType.Video, 2, ImageResolution.Resolution640x480, ImageType.Color)
            _nui.DepthStream.Open(ImageStreamType.Depth, 2, ImageResolution.Resolution320x240, ImageType.DepthAndPlayerIndex)
        Catch ex As Exception
            Actions.GeneralActions.Speak("There was a problem initializing the Kin necked device. Please check the log for more information.")
            LogEvent(ex.Message)
            LogEvent(ex.StackTrace)
        End Try
    End Sub

    Private Sub sp_tkr_SpeechContextChanged(ByVal sender As Object, ByVal e As SpeechTracker.SpeechContextChangedArgs)
        txtBlkContextLoaded.Text = e.context.ToString
        txtBlkContextHistCnt.Text = _context.ContextHistory.Count.ToString
    End Sub

    Private Sub sp_tkr_SpeechDetected(ByVal sender As Object, ByVal e As SpeechTracker.IntentionArgs)
        'here we handle the event thrown by the SpeechTracker when it hears something in one of the grammars
        Select Case e.context
            Case SpeechTracker.Context.General
                Select Case e.general
                    Case SpeechTracker.General.Shutdown
                        Me.Close()
                    Case SpeechTracker.General.Time
                        GeneralActions.SayTime()
                    Case SpeechTracker.General.Log
                    Case SpeechTracker.General.Pulse
                        SpeakResponse()
                    Case SpeechTracker.General.Schedule
                    Case SpeechTracker.General.ColorViewer
                        _trackHands = False ' if we are not on the tab with buttons, we shouldn't track the hands
                        Me.tabItemRGB.Focus()
                    Case SpeechTracker.General.DepthViewer
                        _trackHands = False ' if we are not on the tab with buttons, we shouldn't track the hands
                        Me.tabItemDepth.Focus()
                    Case SpeechTracker.General.SkeletonViewer
                        _trackHands = False ' if we are not on the tab with buttons, we shouldn't track the hands
                        Me.tabItemSkeleton.Focus()
                    Case SpeechTracker.General.Buttons
                        _trackHands = True ' if we are on the tab with buttons, we should assume that the user wants to interact with the buttons
                        Me.tabItemButtons.Focus()
                    Case SpeechTracker.General.Affirmation
                        'todo: implement some intelligence to handle positive feedback
                        GeneralActions.Speak("Thank you.")
                    Case SpeechTracker.General.Thanks
                        GeneralActions.Speak("You are welcome, " & _context.EndUser.Preferred_name)
                    Case SpeechTracker.General.Negative
                        'todo: implement some intelligence to handle negative feedback
                        GeneralActions.Speak("I am sorry.")
                    Case SpeechTracker.General.TrackOff
                        GeneralActions.SpeakAsync("Tracking off")
                        _trackHands = False
                    Case SpeechTracker.General.TrackOn
                        _trackHands = True
                        GeneralActions.SpeakAsync("Tracking on")
                        tabItemButtons.Focus()
                    Case SpeechTracker.General.TranslationView
                        tabItemTranslation.Focus()
                    Case SpeechTracker.General.NewsView
                        tabItemNews.Focus()
                    Case Else
                End Select
            Case SpeechTracker.Context.Entertain
                Select Case e.entertain
                    Case SpeechTracker.Entertain.Music
                    Case SpeechTracker.Entertain.Video
                End Select
            Case SpeechTracker.Context.Meeting
                Select Case e.meeting
                    Case SpeechTracker.Meeting.CaptureAudio
                    Case SpeechTracker.Meeting.CaptureVideo
                    Case SpeechTracker.Meeting.Snapshot
                        Dim image As BitmapSource = CType(colorImage.Source, BitmapSource)
                        image.Save("G:\capture.jpg", ImageFormat.Jpeg)
                End Select
            Case SpeechTracker.Context.Office
                Select Case e.office
                    Case SpeechTracker.Office.Excel
                        'Process.Start("EXCEL")
                        _context.ButtonActionEvaluator.ActionPending = PendingAction.Excel

                    Case SpeechTracker.Office.Outlook
                        Process.Start("IEXPLORE", "http://www.live.com")
                    Case SpeechTracker.Office.PowerPoint
                        If Process.GetProcesses.Any(Function(prc) prc.ProcessName.Contains("POWERPNT")) Then
                            OfficeActions.GivePwrPntFocus()
                        Else
                            Process.Start("POWERPNT")
                        End If
                    Case SpeechTracker.Office.OpenAPresentation
                        _context.ButtonActionEvaluator.ActionPending = PendingAction.Powerpoint
                    Case SpeechTracker.Office.StartPresentation
                        If Not Process.GetProcesses.Any(Function(prc) prc.ProcessName.Contains("POWERPNT")) Then
                            GeneralActions.Speak("I am sorry, but you have not opened a brief to present. I do not know how to assist you.")
                            Exit Sub
                        End If
                        OfficeActions.GivePwrPntFocus()
                        System.Windows.Forms.SendKeys.SendWait("{F5}")
                    Case SpeechTracker.Office.PPTNextSlide
                        OfficeActions.GivePwrPntFocus()
                        System.Windows.Forms.SendKeys.SendWait("{RIGHT}")
                    Case SpeechTracker.Office.PPTPreviousSlide
                        OfficeActions.GivePwrPntFocus()
                        System.Windows.Forms.SendKeys.SendWait("{LEFT}")
                    Case SpeechTracker.Office.Word
                    Case SpeechTracker.Office.OpenADocument
                        _context.ButtonActionEvaluator.ActionPending = PendingAction.Word
                    Case SpeechTracker.Office.OpenAProjectPlan
                        _context.ButtonActionEvaluator.ActionPending = PendingAction.ProjectPlan
                End Select
            Case SpeechTracker.Context.Operations
                Select Case e.operations
                    Case SpeechTracker.Operations.CameraDown
                        CameraDown()
                    Case SpeechTracker.Operations.CameraUp
                        CameraUp()
                    Case SpeechTracker.Operations.CameraCenter
                        CameraCenter()
                    Case SpeechTracker.Operations.SkeletonTracker
                    Case SpeechTracker.Operations.FineControl
                        _cameraControl = CameraControl.Fine
                    Case SpeechTracker.Operations.CourseControl
                        _cameraControl = CameraControl.Course
                End Select
            Case SpeechTracker.Context.Research
                Select Case e.research
                    Case SpeechTracker.Research.Lookup
                    Case SpeechTracker.Research.News
                        tabItemNews.Focus()
                        txtBlkNews.Text = NewsActions.GetTheNews
                    Case SpeechTracker.Research.Spelling
                End Select
            Case SpeechTracker.Context.Translate
                Select Case e.translate
                    Case SpeechTracker.Translate.ArabicEnglish
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("ar", "en", "مرحبا، وآمل كنت تواجه يوم جميل.")
                    Case SpeechTracker.Translate.EnglishArabic
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("en", "ar", "hello, I hope you are having a nice day.")
                    Case SpeechTracker.Translate.EnglishSpanish
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("en", "es", "hello, I hope you are having a nice day.")
                    Case SpeechTracker.Translate.EnglishTurkish
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("en", "tr", "hello, I hope you are having a nice day.")
                    Case SpeechTracker.Translate.SpanishEnglish
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("es", "en", "Hola, espero que está teniendo un buen día.")
                    Case SpeechTracker.Translate.TurkishEnglish
                        tabItemTranslation.Focus()
                        txtBlkTranslation.Text = BingTranslationActions.TranslationRequest("tr", "en", "Merhaba, güzel bir gün yaşıyorsanız umuyoruz.")
                End Select
        End Select
        txtBlkHeard.Text = e.phrase
    End Sub

    Private Sub CameraUp()
        Dim x As Integer = _nui.NuiCamera.ElevationAngle
        x = x + GetCameraDeltaFactor()
        If x > 27 Then
            x = 27
        End If
        _nui.NuiCamera.ElevationAngle = x
    End Sub

    Private Function GetCameraDeltaFactor() As Integer
        Dim delta As Integer
        If _cameraControl = CameraControl.Course Then
            delta = 5
        Else
            delta = 1
        End If
        Return delta
    End Function

    Private Sub CameraDown()
        Dim x As Integer = _nui.NuiCamera.ElevationAngle
        x = x - GetCameraDeltaFactor()
        If x < -27 Then
            x = -27
        End If
        _nui.NuiCamera.ElevationAngle = x
    End Sub

    Private Sub CameraCenter()
        _nui.NuiCamera.ElevationAngle = 0
    End Sub

    Private Sub InitializeButtons()
        _buttons = New List(Of Button)
        _buttons.Add(button1)
        _buttons.Add(button2)
        _buttons.Add(button3)
        _buttons.Add(button4)
        _buttons.Add(button5)
        _buttons.Add(button6)
        _buttons.Add(button7)
        _buttons.Add(button8)
    End Sub

#Region "Button events"
    Private Sub button1_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button1
        'GeneralActions.Speak("You clicked button number one.")
    End Sub

    Private Sub button2_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button2
        'GeneralActions.Speak("You clicked button number two.")
    End Sub

    Private Sub button3_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button3
        'GeneralActions.Speak("You clicked button number three.")
    End Sub

    Private Sub button4_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button4
        'GeneralActions.Speak("You clicked button number four.")
    End Sub

    Private Sub button5_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button5
        'GeneralActions.Speak("You clicked button number five.")
    End Sub

    Private Sub button6_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button6
        'GeneralActions.Speak("You clicked button number six.")
    End Sub

    Private Sub button7_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button7
        'GeneralActions.Speak("You clicked button number seven.")
    End Sub

    Private Sub button8_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        _context.ButtonActionEvaluator.SelectedButton = ButtonSelected.Button8
        'GeneralActions.Speak("You clicked button number eight.")
    End Sub
#End Region

    Private Sub UninitializeNui()
        If (_nui IsNot Nothing) AndAlso (_nuiInitialized) Then
            _nui.Uninitialize()
            _nuiInitialized = False
        End If
    End Sub

    Private Sub LoadRfidAccounts()
        'I used an RFID reader in the project for GMU.
        'It gave me a convenient way to identify users.
        'I have removed the need for it in this code, since most readers won't have a Phidgets RFID reader to play with.
        _knownPeople = New Dictionary(Of String, Person)
        _knownPeople.Add("110033e117", New Person("110033e117", Person.Gender.Male, "Leland Holmquest", "Leland"))
        _knownPeople.Add("110033d0bd", New Person("110033d0bd", Person.Gender.Female, "Jane Doe", "Jane"))
        _knownPeople.Add("01068df9e2", New Person("01068df9e2", Person.Gender.Male, "User One", "One"))
        _knownPeople.Add("0107ee5ccd", New Person("0107ee5ccd", Person.Gender.Male, "User two", "Two"))
        _knownPeople.Add("01068dfb65", New Person("01068dfb65", Person.Gender.Female, "Kenzy Holmquest", "Kenzy"))
        _knownPeople.Add("0107ee8771", New Person("0107ee8771", Person.Gender.Female, "Shahrazad Holmquest", "Sherrie"))
        _knownPeople.Add("No tag in view", New Person("No tag in view", Person.Gender.Unknown, "no person", "no person"))
    End Sub

    Private Shared Sub LogEvent(ByVal text As String)
        Dim source As String = "Project Lily"

        If Not EventLog.SourceExists(source) Then
            EventLog.CreateEventSource(source, "Application")
        End If

        EventLog.WriteEntry(source, text)
    End Sub

    ''' <summary>
    ''' This method is used by Dispatcher to update the text in the txtBlkRFIDTag textblock.
    ''' This is necessary because the RFID library is operating on a different thread and cannot update the UI thread.
    ''' </summary>
    ''' <param name="text">(string) that represents the desired text in txtBlkRFIDTag Textblock.</param>
    Private Sub SetRFIDTagText(ByVal text As String)
        If text = "No tag in view" Then
            txtBlkRFIDTag.Text = "No tag currently attached."
            Exit Sub
        End If

        If Not _knownPeople.ContainsKey(text) Then
            'the rfid read is not known to the system =>
            ' advise user and bail from method
            GeneralActions.SpeakAsync("An R F I D was read that I am not aware of. If you want me to make use of this I D, please give me the knowledge. Thank you.")
            txtBlkRFIDTag.Text = text
            Exit Sub
        End If
        Dim txt As String = ""
        Dim acnt As Person = _knownPeople(text)
        txt = acnt.Full_name & ", (preferred name: " & acnt.Preferred_name & ") logged in."
        txtBlkRFIDTag.Text = txt
        If Not acnt.greetedToday Then
            'person has not been greeted by system yet - greet
            GeneralActions.Greet(acnt.Preferred_name)
            acnt.LastGreeted = Date.Now
            ' we need to update this account => remove and re-add
            _knownPeople.Remove(acnt.Rfid)
            _knownPeople.Add(acnt.Rfid, acnt)
        End If
    End Sub

    ''' <summary>
    ''' This method is used by Dispatcher to insert an RFID Tag into the history.
    ''' </summary>
    ''' <param name="tag">(string) that represents the RFID Tag recognized by the system.</param>
    Private Sub QueueRFIDHistory(ByVal tag As String)
        _rfidHistory.Enqueue(tag)
    End Sub

    ''' <summary>
    ''' This method gives a verbal response to a pulse request from the user.
    ''' Some reponses use a personal identifier like "Yes, [name]".
    ''' To make it more humanistic, we randomly substitute the user's name with a gender appropriate title.
    ''' </summary>
    Private Sub SpeakResponse()
        Dim ac As String = ""
        Dim rand1 As New Random
        Dim x As Integer = rand1.Next(10)
        If (x Mod 2) = 0 Then
            ac = _context.EndUser.Preferred_name
        Else
            Select Case _context.EndUser.PersonGender
                Case Person.Gender.Male
                    ac = "sir"
                Case Person.Gender.Female
                    ac = "ma'am"
                Case Else
                    ac = "boss"
            End Select
        End If
        Dim rand As New Random
        Dim r As Integer = rand.Next(_pulseResponses.Length)
        If _pulseResponses(r).Contains("{0}") Then
            GeneralActions.Speak(String.Format(_pulseResponses(r), ac))
        Else
            GeneralActions.Speak(_pulseResponses(r))
        End If
    End Sub

    Private Sub chkAEC_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)

    End Sub

#Region "RFID Events"
    'Private Sub rfid_TagLost(ByVal sender As Object, ByVal e As TagEventArgs)
    '      Dispatcher.Invoke(DispatcherPriority.Normal, New Action(Of String)(AddressOf SetRFIDTagText), "No tag in view")
    '      CType(sender, RFID).LED = False
    '      currentRFIDTag = String.Empty
    '  End Sub

    '  Private Sub rfid_Tag(ByVal sender As Object, ByVal e As TagEventArgs)
    '      Dispatcher.Invoke(DispatcherPriority.Normal, New Action(Of String)(AddressOf SetRFIDTagText), e.Tag)
    '      Dispatcher.Invoke(DispatcherPriority.Normal, New Action(Of String)(AddressOf QueueRFIDHistory), e.Tag)
    '      CType(sender, RFID).LED = True
    '      currentRFIDTag = e.Tag
    '  End Sub

    '  Private Sub rfid_Error(ByVal sender As Object, ByVal e As ErrorEventArgs)
    '      LogEvent("RFID error: " & e.Description)
    '      LogEvent("RFID error: " & e.exception.Message & " STACK: " & e.exception.StackTrace)
    '  End Sub

    '  Private Sub rfid_Detach(ByVal sender As Object, ByVal e As DetachEventArgs)
    '      Console.WriteLine("RFID reader detached")
    '  End Sub

    '  Private Sub rfid_Attach(ByVal sender As Object, ByVal e As AttachEventArgs)
    '      Console.WriteLine("RFID reader attached")
    '  End Sub
#End Region

#Region "WPF Form Events"
    Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
    End Sub

    Private Sub Window_GotKeyboardFocus(ByVal sender As Object, ByVal e As KeyboardFocusChangedEventArgs)

    End Sub

    Private Sub Window_Activated(ByVal sender As Object, ByVal e As EventArgs)

    End Sub

    Private Sub Window_ContentRendered(ByVal sender As Object, ByVal e As EventArgs)
        Actions.GeneralActions.Greet(_context.EndUser.Preferred_name) ' Environment.UserName)
        Actions.GeneralActions.SayTime()
        'If rfid.Attached Then
        '         Actions.GeneralActions.Speak("The R F I D reader is ready.")
        '     Else
        '         Actions.GeneralActions.Speak("There is a problem with the R F I D reader.")
        '     End If
        If _nuiInitialized Then
            GeneralActions.Speak("The kin necked unit is ready.")
        Else
            GeneralActions.Speak("The kin necked unit is not available. Without it, I am blind and deaf, and therefore not truly functional. Please look into correcting the problem.")
        End If

        GeneralActions.Speak("I am Lily. I am on line and ready to serve.")
    End Sub

    Private Sub Window_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        GeneralActions.Speak("I am shutting down this service per your direction, " & _context.EndUser.Preferred_name)
        '     TypeOf window Is Function(closing) shutdown Kinect and RFID reader Shutdown RFID reader rfid.LED = False 'shut off LED
        '     rfid.close()
        '     rfid = Nothing
        '     Actions.GeneralActions.Speak("The R F I D reader has shut down.")
        '     Console.WriteLine("RFID reader is shutdown.")
        If _sp_tkr IsNot Nothing Then
            _sp_tkr.KeepListening = False
        End If

        'Shutdown Kinect
        UninitializeNui()
        Console.WriteLine("Kinect unit released.")
        Actions.GeneralActions.Speak("The kin necked unit has shut down.")


        GeneralActions.Speak("The service is shutting down.")
        Actions.GeneralActions.SayTime()
        Actions.GeneralActions.Goodbye(Environment.UserName)
    End Sub
#End Region

#End Region

#Region "Public Methods"

#End Region

End Class
